"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TezosContractIntrospector = void 0;
const TezosConseilClient_1 = require("../../reporting/tezos/TezosConseilClient");
const TezosLanguageUtil_1 = require("./TezosLanguageUtil");
const EntryPointTemplate = __importStar(require("./lexer/EntryPointTemplate"));
const nearley = __importStar(require("nearley"));
var TezosContractIntrospector;
(function (TezosContractIntrospector) {
    function generateEntryPointsFromParams(params) {
        const parser = new nearley.Parser(nearley.Grammar.fromCompiled(EntryPointTemplate.default));
        parser.feed(TezosLanguageUtil_1.TezosLanguageUtil.normalizeMichelineWhiteSpace(TezosLanguageUtil_1.TezosLanguageUtil.stripComments(params)));
        const entryPoints = parser.results[0];
        if (entryPoints.length === 1) {
            entryPoints[0].name = 'default';
        }
        return entryPoints;
    }
    TezosContractIntrospector.generateEntryPointsFromParams = generateEntryPointsFromParams;
    function generateEntryPointsFromCode(contractCode) {
        const contractParameter = TezosLanguageUtil_1.TezosLanguageUtil.preProcessMichelsonScript(contractCode)[0];
        return generateEntryPointsFromParams(contractParameter);
    }
    TezosContractIntrospector.generateEntryPointsFromCode = generateEntryPointsFromCode;
    function generateEntryPointsFromAddress(conseilServer, network, contractAddress) {
        return __awaiter(this, void 0, void 0, function* () {
            const account = yield TezosConseilClient_1.TezosConseilClient.getAccount(conseilServer, network, contractAddress);
            const contractCode = account.script;
            return generateEntryPointsFromCode(contractCode);
        });
    }
    TezosContractIntrospector.generateEntryPointsFromAddress = generateEntryPointsFromAddress;
})(TezosContractIntrospector = exports.TezosContractIntrospector || (exports.TezosContractIntrospector = {}));
//# sourceMappingURL=TezosContractIntrospector.js.map