import { KeyStore, Signer } from '../../../types/ExternalInterfaces';
import * as TezosTypes from '../../../types/tezos/TezosChainTypes';
export declare namespace BabylonDelegationHelper {
    function verifyDestination(server: string, address: string): Promise<boolean>;
    function verifyScript(script: string): boolean;
    function getSimpleStorage(server: string, address: string): Promise<{
        administrator: string;
    }>;
    function setDelegate(server: string, signer: Signer, keyStore: KeyStore, contract: string, delegate: string, fee: number): Promise<TezosTypes.OperationResult>;
    function unSetDelegate(server: string, signer: Signer, keyStore: KeyStore, contract: string, fee: number): Promise<TezosTypes.OperationResult>;
    function withdrawDelegatedFunds(server: string, signer: Signer, keyStore: KeyStore, contract: string, fee: number, amount: number): Promise<TezosTypes.OperationResult>;
    function sendDelegatedFunds(server: string, signer: Signer, keyStore: KeyStore, contract: string, fee: number, amount: number, destination: string): Promise<TezosTypes.OperationResult>;
    function depositDelegatedFunds(server: string, signer: Signer, keyStore: KeyStore, contract: string, fee: number, amount: number): Promise<TezosTypes.OperationResult>;
    function deployManagerContract(server: string, signer: Signer, keyStore: KeyStore, delegate: string, fee: number, amount: number, optimizeFee?: boolean): Promise<TezosTypes.OperationResult>;
}
