import { ConseilServerInfo } from '../../../types/conseil/QueryTypes';
import { MultiAssetSimpleStorage } from './tzip12/MultiAssetTokenHelper';
export declare namespace HicNFTHelper {
    const objktsAddress = "KT1RJ6PbjHpwc3M5rw5s2Nbmefwbuwbdxton";
    const hDaoAddress = "KT1AFA2mwNUMNd4SsujE1YYp29vd8BZejyKW";
    function getStorage(server: string, address: string): Promise<MultiAssetSimpleStorage>;
    function getCollection(tokenMapId: number, managerAddress: string, serverInfo: ConseilServerInfo): Promise<any[]>;
    function getCollectionSize(tokenMapId: number, managerAddress: string, serverInfo: ConseilServerInfo): Promise<number>;
    function getBalance(server: string, mapId: number, address: string): Promise<number>;
    function getTokenInfo(serverInfo: ConseilServerInfo, mapId?: number): Promise<{
        holders: number;
        totalBalance: number;
    }>;
    function getNFTObjectDetails(server: string, objectId: number): Promise<{
        name: any;
        description: any;
        creators: any;
        artifactUrl: string;
        artifactType: any;
    }>;
}
