import { KeyStore, Signer } from '../../../types/ExternalInterfaces';
export declare namespace KolibriTokenHelper {
    function verifyDestination(server: string, address: string): Promise<boolean>;
    function verifyScript(script: string): boolean;
    function getAccountBalance(server: string, mapid: number, account: string): Promise<number>;
    function getAccountAllowance(server: string, mapid: number, account: string, source: string): Promise<any>;
    function getSimpleStorage(server: string, address: string): Promise<{
        mapid: number;
        supply: number;
        administrator: string;
        paused: boolean;
    }>;
    function getTokenSupply(server: string, address: string): Promise<number>;
    function getAdministrator(server: string, address: string): Promise<string>;
    function getPaused(server: string, address: string): Promise<boolean>;
    function transferBalance(server: string, signer: Signer, keystore: KeyStore, contract: string, fee: number, source: string, destination: string, amount: number, gas: number, freight: number): Promise<string>;
    function approveBalance(server: string, signer: Signer, keystore: KeyStore, contract: string, fee: number, destination: string, amount: number, gas: number, freight: number): Promise<string>;
    function activateLedger(server: string, signer: Signer, keystore: KeyStore, contract: string, fee: number, gas: number, freight: number): Promise<string>;
    function deactivateLedger(server: string, signer: Signer, keystore: KeyStore, contract: string, fee: number, gas: number, freight: number): Promise<string>;
    function setAdministrator(server: string, signer: Signer, keystore: KeyStore, contract: string, address: string, fee: number, gas: number, freight: number): Promise<string>;
    function mint(server: string, signer: Signer, keystore: KeyStore, contract: string, fee: number, destination: string, amount: number, gas?: number, freight?: number): Promise<string>;
    function burn(server: string, signer: Signer, keystore: KeyStore, contract: string, fee: number, source: string, amount: number, gas: number, freight: number): Promise<string>;
}
