"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TCFBakerRegistryHelper = void 0;
const blakejs = __importStar(require("blakejs"));
const jsonpath_plus_1 = require("jsonpath-plus");
const TezosMessageUtil_1 = require("../TezosMessageUtil");
const TezosNodeReader_1 = require("../TezosNodeReader");
var TCFBakerRegistryHelper;
(function (TCFBakerRegistryHelper) {
    function verifyDestination(server, address) {
        return __awaiter(this, void 0, void 0, function* () {
            const contract = yield TezosNodeReader_1.TezosNodeReader.getAccountForBlock(server, 'head', address);
            if (!!!contract.script) {
                throw new Error(`No code found at ${address}`);
            }
            const k = Buffer.from(blakejs.blake2s(contract['script'].toString(), null, 16)).toString('hex');
            if (k !== '1527ddf08bdf582dce0b28c051044897') {
                throw new Error(`Contract at ${address} does not match the expected code hash`);
            }
            return true;
        });
    }
    TCFBakerRegistryHelper.verifyDestination = verifyDestination;
    function getSimpleStorage(server, address) {
        return __awaiter(this, void 0, void 0, function* () {
            const storageResult = yield TezosNodeReader_1.TezosNodeReader.getContractStorage(server, address);
            return {
                mapid: parseInt((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].int', json: storageResult })[0]),
                owner: (0, jsonpath_plus_1.JSONPath)({ path: '$.args[1].args[0].string', json: storageResult })[0],
                signupFee: parseInt((0, jsonpath_plus_1.JSONPath)({ path: '$.args[1].args[1].args[0].int', json: storageResult })[0]),
                updateFee: parseInt((0, jsonpath_plus_1.JSONPath)({ path: '$.args[1].args[1].args[1].int', json: storageResult })[0])
            };
        });
    }
    TCFBakerRegistryHelper.getSimpleStorage = getSimpleStorage;
    function updateRegistration(server, address, baker, name, isAcceptingDelegation, detailsURL, payoutShare) {
        return __awaiter(this, void 0, void 0, function* () {
        });
    }
    TCFBakerRegistryHelper.updateRegistration = updateRegistration;
    function queryRegistration(server, mapid, baker) {
        return __awaiter(this, void 0, void 0, function* () {
            const key = TezosMessageUtil_1.TezosMessageUtils.encodeBigMapKey(Buffer.from(TezosMessageUtil_1.TezosMessageUtils.writePackedData(baker, 'key_hash'), 'hex'));
            const mapResult = yield TezosNodeReader_1.TezosNodeReader.getValueForBigMapKey(server, mapid, key);
            if (!!!mapResult) {
                return undefined;
            }
            const textDecoder = new TextDecoder();
            const paymentConfigMask = Number((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[1].args[1].args[1].args[0].args[1].int', json: mapResult })[0]);
            return {
                name: textDecoder.decode(Buffer.from((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[0].args[0].args[0].bytes', json: mapResult })[0], 'hex')),
                isAcceptingDelegation: Boolean((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[0].args[0].args[1].prim', json: mapResult })[0]),
                externalDataURL: textDecoder.decode(Buffer.from((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[0].args[1].bytes', json: mapResult })[0], 'hex')),
                split: Number((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[1].args[0].args[0].int', json: mapResult })[0]) / 10000,
                paymentAccounts: (0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[1].args[0].args[1]..string', json: mapResult }),
                minimumDelegation: Number((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[1].args[1].args[0].args[0].args[0].int', json: mapResult })[0]),
                isGreedy: Boolean((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[1].args[1].args[0].args[0].args[1].prim', json: mapResult })[0]),
                payoutDelay: Number((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[1].args[1].args[0].args[1].args[0].int', json: mapResult })[0]),
                payoutFrequency: Number((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[1].args[1].args[0].args[1].args[1].args[0].int', json: mapResult })[0]),
                minimumPayout: Number((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[1].args[1].args[0].args[1].args[1].args[1].int', json: mapResult })[0]),
                isCheap: Boolean((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[1].args[1].args[1].args[0].args[0].prim', json: mapResult })[0]),
                paymentConfig: {
                    payForOwnBlocks: Boolean(paymentConfigMask & 1),
                    payForEndorsements: Boolean(paymentConfigMask & 2),
                    payGainedFees: Boolean(paymentConfigMask & 4),
                    payForAccusationGains: Boolean(paymentConfigMask & 8),
                    subtractLostDepositsWhenAccused: Boolean(paymentConfigMask & 16),
                    subtractLostRewardsWhenAccused: Boolean(paymentConfigMask & 32),
                    subtractLostFeesWhenAccused: Boolean(paymentConfigMask & 64),
                    payForRevelation: Boolean(paymentConfigMask & 128),
                    subtractLostRewardsWhenMissRevelation: Boolean(paymentConfigMask & 256),
                    subtractLostFeesWhenMissRevelation: Boolean(paymentConfigMask & 512),
                    compensateMissedBlocks: !Boolean(paymentConfigMask & 1024),
                    payForStolenBlocks: Boolean(paymentConfigMask & 2048),
                    compensateMissedEndorsements: !Boolean(paymentConfigMask & 4096),
                    compensateLowPriorityEndorsementLoss: !Boolean(paymentConfigMask & 8192)
                },
                overdelegationThreshold: Number((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[1].args[1].args[1].args[1].args[0].int', json: mapResult })[0]),
                subtractRewardsFromUninvitedDelegation: Boolean((0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[0].args[0].args[1].args[1].args[1].args[1].args[1].prim', json: mapResult })[0]),
                recordManager: (0, jsonpath_plus_1.JSONPath)({ path: '$.args[0].args[1].args[0].string', json: mapResult })[0],
                timestamp: new Date((0, jsonpath_plus_1.JSONPath)({ path: '$.args[1].string', json: mapResult })[0])
            };
        });
    }
    TCFBakerRegistryHelper.queryRegistration = queryRegistration;
})(TCFBakerRegistryHelper = exports.TCFBakerRegistryHelper || (exports.TCFBakerRegistryHelper = {}));
//# sourceMappingURL=TCFBakerRegistryHelper.js.map